
%%%%%%fish school scattering model%%%%%%
clear; 
clc;

De = 1026; %% sea water density, kg/m3%%
C = 1500; %% sound speed in water,m/s%%
PA = 1.01e5; %%ambient pressure,Pa%%%%

a = 0.037; %% bubble radius,m%%
He = 1.4; %% ratio of gas specific heats%%
Vi = 50;  %% viscosity of fish flesh,Pa.s %%
m = De / (4*pi*a);%% inertial mass of the bubble%%
Ad = (3*He*PA)/(4*pi*a^3); %% adiabatic stiffness%%
P0 = 1;   %% the amplitude %%
w0=(Ad/m)^0.5;%% the resonance frequency
f0=w0/2/pi;

d = 0.6; %% the length of the school unit,m%%
zyx=[0.2,0.2,0.2; 0.2, -0.2, 0.2; 0.2, 0.6, 0.2; 0.6, 0.2, 0.2; -0.2, 0.2, 0.2]/2*3;
zzz= [d*(dec2bin(0:7)-'0'); zyx];
bb=rand(13,3);
aa=bb/25*4;
xyz=zzz+aa;
[startp endp] = meshgrid(1:13);
r = reshape( sqrt(sum((xyz(startp,:) - xyz(endp,:)).^2,2)),[13 13]);

f=1;
Ts=0;

while (f<5000)    
    th=0; 
    k=2*pi*f/C;
    b=a*m*(2*pi*f)^2/C+2*Vi*m/De/a^2; 
  
    
    
    x20(f)=f;   
    y20(f)=Ts;

    for n=1:13
        for j=1:13
                 
            if n==j
                M(n,j)=Ad-(2*pi*f)^2*m+i*(2*pi*f*b);
            else
                M(n,j)=-(2*pi*f)^2/(4*pi)*De*exp(-i*k*r(n,j))/r(n,j);
            end
        end
       phaseangle(n,1)= dot([cos(th),sin(th),0],xyz(n,:))/norm([cos(th),sin(th),0]);

    end
       phase=phaseangle*k;
       P= -exp(i*phase);
       PP=exp(i*phase);
       
       M1=inv(M);
       
       V=M1*P; 
       
       V1=V.*PP;
       
       V2=sum(V1);
       V3=abs(V2);
       V4=V3^2; 
       
       
      Ts=10*log10((2*pi*f)^4*De^2*V4/16/pi^2/P0^2);
      
      f=f+1;
    
end

plot(x20,y20);
save('school15','x20','y20' );










        
       
    
    
    















