% Reading EK60 raw data file
% Simrad, Lars Nonboe Andersen, 1/8-05|

clear all
close all

[filename, pathname] = uigetfile('*.raw', 'Select raw data file','H:\SIMRAD0418');
fname = [pathname filename];

headerlength = 12; % Bytes in datagram header

pingno = 0;



fid = fopen(fname,'r');
if (fid==-1)
    error('Could not open file');
else
    % Read configuration datagram
    length = fread(fid,1,'int32');
    dgheader = readdgheader(fid);
    configheader = readconfigheader(fid);
    for i=1:configheader.transducercount,
        configtransducer(i) = readconfigtransducer(fid);
    end
    config = struct('header',configheader,'transducer',configtransducer);
    length = fread(fid,1,'int32');  

if  configtransducer(1,2).frequency > 0 
    flag1=2;
else
    flag1=1;
end
sel = 1;
count=1;
    
    % Read NMEA, Annotation, or Sample datagram
 while (1) 
        length = fread(fid,1,'int32');
        if (feof(fid))
            break
        end
        dgheader = readdgheader(fid);
        switch (dgheader.datagramtype)
        case 'NME0' % NMEA datagram
            text = readtextdata(fid,length-headerlength);
            %disp('NME0'); 
        case 'TAG0' % Annotation datagram
            text = readtextdata(fid,length-headerlength);
            %disp('TAG0');
        case 'RAW0' % Sample datagram
            sampledata = readsampledata(fid);
            %disp('RAW0');
            int1=0;
            int2=0;
            
            sampledata = applytvg(config,sampledata);
            
            i=1;
            number = size(sampledata.svrange);
            sampledata.svrange(number(1,1)+1)=25;
               
                 while sampledata.svrange(i) < 25
                 int1 = int1 + sampledata.sv(i)*sampledata.svrange(i);
                 int2 = int2 + sampledata.sv(i);
                 i=i+1;
                 end
                
            sampledata.svrange(number(1,1)+1)=[]
            
            if flag1==2
                if sel==1
                              
                cg1(count)= int1/int2;
                sampledata1(count,:)=sampledata;
               figure(1) %*
               plot(sampledata.svrange,sampledata.sv)%*
               c1(count,:) = struct2cell(sampledata1(count,:)); % the data is correct 27*4 cell
                            
         
                 sel=2;
                
                else
                    
                cg2(count)= int1/int2;
                sampledata2(count,:)=sampledata;
                sel=1;
              figure(2) %*
              plot(sampledata.svrange,sampledata.sv)%*
              c2(count,:) = struct2cell(sampledata2(count,:)); % the data is correct 27*4 cell 
          

                count = count +1;
                end
                
            else
               
                cg1(count)= int1/int2;
                sampledata1(count,:)=sampledata;
                count = count +1;
             figure(3)%*
             plot(sampledata.svrange,sampledata.sv)%*
               
             
            end
            % pause

            pingno = pingno +1;
            
            str = sprintf('Read ping no. %i',pingno);
            home
            disp(str);
        otherwise
            error(strcat('Unknown datagram ''',dgheader.datagramtype,''' in file'));
        end
        length = fread(fid,1,'int32');

 end
  

 %Average all pings and plot them% 
    % for transducer 1
       sv1=c1(1,2);
       for n=1:44;
            sv1=[sv1, c1(n,2)]; % cell 
       end  

       sv1ma= cell2mat(sv1);% convert cell into matrix 
       sv1aver= mean(sv1ma,2);% get the averge 
       sv125=sv1aver; 
       save sv125; 

       distancecell=c1(1,1);
       distance=cell2mat(distancecell);
        

       figure(4) 
       plot(distance, sv1aver),title 'Transducer 1' , xlabel('Distance [m]'),ylabel('Power [dB]'),axis([0 5 -110 -40]), grid on
       
     
       %for transducer 2 
       sv2=c2(1,2);
       for m=1:44;
            sv2=[sv2, c2(m,2)]; % cell 
       end  

       sv2ma= cell2mat(sv2);% convert cell into matrix 
       sv2aver= mean(sv2ma,2);% get the averge 
       sv225=sv2aver; 
       save sv225; 

       figure(5) 
       plot(distance, sv2aver),title 'Transducer 2', xlabel('Distance [m]'),ylabel('Power [dB]'),axis([0 5 -110 -40]), grid on

 
 
 
    fclose(fid);
    
    
    figure(6); 
    plot(cg1),title 'Transducer 1', xlabel('Pingno.'), ylabel('Gravity center [m]'), grid on
    figure(7); 
    plot(cg2), title 'Transducer 2',xlabel('Pingno.'),ylabel('Gravity center [m]'), grid on
    
     
end


    
    
